// Code generated by goctl. DO NOT EDIT.
// goctl 1.7.2

package handler

import (
	"net/http"

	auth "tianyuan-api/apps/admin/internal/handler/auth"
	product "tianyuan-api/apps/admin/internal/handler/product"
	review "tianyuan-api/apps/admin/internal/handler/review"
	user "tianyuan-api/apps/admin/internal/handler/user"
	"tianyuan-api/apps/admin/internal/svc"

	"github.com/zeromicro/go-zero/rest"
)

func RegisterHandlers(server *rest.Server, serverCtx *svc.ServiceContext) {
	server.AddRoutes(
		[]rest.Route{
			{
				Method:  http.MethodPost,
				Path:    "/login",
				Handler: auth.LoginHandler(serverCtx),
			},
		},
		rest.WithPrefix("/api/admin/auth"),
	)

	server.AddRoutes(
		rest.WithMiddlewares(
			[]rest.Middleware{serverCtx.AuthInterceptor},
			[]rest.Route{
				{
					Method:  http.MethodGet,
					Path:    "/:productId",
					Handler: product.GetProductByIdHandler(serverCtx),
				},
				{
					Method:  http.MethodPost,
					Path:    "/create",
					Handler: product.CreateProductHandler(serverCtx),
				},
				{
					Method:  http.MethodPost,
					Path:    "/delete",
					Handler: product.DeleteProductHandler(serverCtx),
				},
				{
					Method:  http.MethodGet,
					Path:    "/list",
					Handler: product.GetProductListHandler(serverCtx),
				},
				{
					Method:  http.MethodPost,
					Path:    "/update",
					Handler: product.UpdateProductHandler(serverCtx),
				},
			}...,
		),
		rest.WithPrefix("/api/admin/product"),
	)

	server.AddRoutes(
		rest.WithMiddlewares(
			[]rest.Middleware{serverCtx.AuthInterceptor},
			[]rest.Route{
				{
					Method:  http.MethodGet,
					Path:    "/pending",
					Handler: review.GetPendingEnterpriseHandler(serverCtx),
				},
				{
					Method:  http.MethodPost,
					Path:    "/review",
					Handler: review.ReviewEnterpriseHandler(serverCtx),
				},
			}...,
		),
		rest.WithPrefix("/api/admin/enterprise"),
	)

	server.AddRoutes(
		rest.WithMiddlewares(
			[]rest.Middleware{serverCtx.AuthInterceptor},
			[]rest.Route{
				{
					Method:  http.MethodGet,
					Path:    "/info",
					Handler: user.GetUserInfoHandler(serverCtx),
				},
			}...,
		),
		rest.WithPrefix("/api/admin/user"),
	)

	server.AddRoutes(
		rest.WithMiddlewares(
			[]rest.Middleware{serverCtx.AuthInterceptor},
			[]rest.Route{
				{
					Method:  http.MethodGet,
					Path:    "/user/list",
					Handler: user.GetUserListHandler(serverCtx),
				},
				{
					Method:  http.MethodPost,
					Path:    "/user/recharge",
					Handler: user.RechargeHandler(serverCtx),
				},
			}...,
		),
		rest.WithPrefix("/api/admin/user"),
	)
}
