package config

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/rest"
	"github.com/zeromicro/go-zero/zrpc"
)

type Config struct {
	rest.RestConf
	DataSource   string          // 数据库连接的 DSN 字符串
	CacheRedis   cache.CacheConf // 缓存配置，使用 go-zero 自带的缓存配置结构体
	SentinelRpc  zrpc.RpcClientConf
	UserRpc      zrpc.RpcClientConf
	KqPusherConf KqPusherConf
	WestConfig   WestConfig
	YushanConfig YushanConfig
}
type KqPusherConf struct {
	Brokers []string
	Topic   string
}
type WestConfig struct {
	Url            string
	Key            string
	SecretId       string
	SecretSecondId string
}
type YushanConfig struct {
	ApiKey string
	AcctID string
	Url    string
}
