package IVYZ

import (
	"net/http"
	"tianyuan-api/pkg/errs"
	"tianyuan-api/pkg/response"

	"github.com/zeromicro/go-zero/rest/httpx"
	"tianyuan-api/apps/api/internal/logic/IVYZ"
	"tianyuan-api/apps/api/internal/svc"
	"tianyuan-api/apps/api/internal/types"
)

func IVYZ5733Handler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.Request
		if err := httpx.Parse(r, &req); err != nil {
			response.Fail(r.Context(), w, errs.ErrParamValidation, nil)
			return
		}
		l := IVYZ.NewIVYZ5733Logic(r.Context(), svcCtx)
		resp, err := l.IVYZ5733(&req)
		if err != nil {
			response.Fail(r.Context(), w, err, resp)
		} else {
			response.Success(r.Context(), w, resp)
		}
	}
}
