package validator

// 通用字段结构体
type MobileNo struct {
	MobileNo string `json:"mobile_no" validate:"required,min=11,max=11,validMobileNo"`
}
type StartDate struct {
	StartDate string `json:"start_date" validate:"required,validDate"`
}
type IDCard struct {
	IDCard string `json:"id_card" validate:"required,validIDCard"`
}

type Name struct {
	Name string `json:"name" validate:"required,min=1,validName"`
}

type FLXG3D56Request struct {
	MobileNo  string `json:"mobile_no" validate:"required,min=11,max=11,validMobileNo"`
	IDCard    string `json:"id_card" validate:"required,validIDCard"`
	Name      string `json:"name" validate:"required,min=1,validName"`
	TimeRange string `json:"time_range" validate:"omitempty,validTimeRange"` // 非必填字段
}
type FLXG0V3BRequest struct {
	IDCard string `json:"id_card" validate:"required,validIDCard"`
	Name   string `json:"name" validate:"required,min=1,validName"`
}
type FLXG0V4BRequest struct {
	IDCard   string `json:"id_card" validate:"required,validIDCard"`
	Name     string `json:"name" validate:"required,min=1,validName"`
	AuthDate string `json:"auth_date" validate:"required,validAuthDate" encrypt:"false"`
}
type FLXG54F5Request struct {
	MobileNo string `json:"mobile_no" validate:"required,min=11,max=11,validMobileNo"`
}
type FLXG162ARequest struct {
	MobileNo string `json:"mobile_no" validate:"required,min=11,max=11,validMobileNo"`
	IDCard   string `json:"id_card" validate:"required,validIDCard"`
	Name     string `json:"name" validate:"required,min=1,validName"`
}
type FLXG970FRequest struct {
	IDCard string `json:"id_card" validate:"required,validIDCard"`
	Name   string `json:"name" validate:"required,min=1,validName"`
}
type FLXG5876Request struct {
	MobileNo string `json:"mobile_no" validate:"required,min=11,max=11,validMobileNo"`
}
type FLXG9687Request struct {
	MobileNo string `json:"mobile_no" validate:"required,min=11,max=11,validMobileNo"`
	IDCard   string `json:"id_card" validate:"required,validIDCard"`
	Name     string `json:"name" validate:"required,min=1,validName"`
}
type FLXGC9D1Request struct {
	MobileNo string `json:"mobile_no" validate:"required,min=11,max=11,validMobileNo"`
	IDCard   string `json:"id_card" validate:"required,validIDCard"`
	Name     string `json:"name" validate:"required,min=1,validName"`
}
type FLXGCA3DRequest struct {
	IDCard string `json:"id_card" validate:"required,validIDCard"`
	Name   string `json:"name" validate:"required,min=1,validName"`
}
type FLXGDEC7Request struct {
	IDCard string `json:"id_card" validate:"required,validIDCard"`
	Name   string `json:"name" validate:"required,min=1,validName"`
}

type IVYZ0B03Request struct {
}
type IVYZ385ERequest struct {
	IDCard string `json:"id_card" validate:"required,validIDCard"`
	Name   string `json:"name" validate:"required,min=1,validName"`
}
type IVYZ5733Request struct {
	Name   string `json:"name" validate:"required,min=1,validName"`
	IDCard string `json:"id_card" validate:"required,validIDCard"`
}
type IVYZ9363Request struct {
	ManName     string `json:"man_name" validate:"required,min=1,validName"`
	ManIDCard   string `json:"man_id_card" validate:"required,validIDCard"`
	WomanName   string `json:"woman_name" validate:"required,min=1,validName"`
	WomanIDCard string `json:"woman_id_card" validate:"required,validIDCard"`
}

type JRZQ0A03Request struct {
	MobileNo string `json:"mobile_no" validate:"required,min=11,max=11,validMobileNo"`
	IDCard   string `json:"id_card" validate:"required,validIDCard"`
	Name     string `json:"name" validate:"required,min=1,validName"`
}
type JRZQ4AA8Request struct {
	MobileNo string `json:"mobile_no" validate:"required,min=11,max=11,validMobileNo"`
	IDCard   string `json:"id_card" validate:"required,validIDCard"`
	Name     string `json:"name" validate:"required,min=1,validName"`
}
type JRZQ8203Request struct {
	MobileNo string `json:"mobile_no" validate:"required,min=11,max=11,validMobileNo"`
	IDCard   string `json:"id_card" validate:"required,validIDCard"`
	Name     string `json:"name" validate:"required,min=1,validName"`
}
type JRZQDBCERequest struct {
	MobileNo string `json:"mobile_no" validate:"required,min=11,max=11,validMobileNo"`
	IDCard   string `json:"id_card" validate:"required,validIDCard"`
	BankCard string `json:"bank_card" validate:"required,validBankCard"`
	Name     string `json:"name" validate:"required,min=1,validName"`
}
type QYGL2ACDRequest struct {
	EntName     string `json:"ent_name" validate:"required,min=1,validName"`
	LegalPerson string `json:"legal_person" validate:"required,min=1,validName"`
	EntCode     string `json:"ent_code" validate:"required,validUSCI"`
}
type QYGL6F2DRequest struct {
	IDCard string `json:"id_card" validate:"required,validIDCard"`
}
type QYGL45BDRequest struct {
	EntName     string `json:"ent_name" validate:"required,min=1,validName"`
	LegalPerson string `json:"legal_person" validate:"required,min=1,validName"`
	EntCode     string `json:"ent_code" validate:"required,validUSCI"`
	IDCard      string `json:"id_card" validate:"required,validIDCard"`
}
type QYGL8261Request struct {
	EntName string `json:"ent_name" validate:"required,min=1,validName"`
}
type QYGL8271Request struct {
	EntName  string `json:"ent_name" validate:"required,min=1,validName"`
	EntCode  string `json:"ent_code" validate:"required,validUSCI"`
	AuthDate string `json:"auth_date" validate:"required,validAuthDate" encrypt:"false"`
}
type QYGLB4C0Request struct {
	IDCard string `json:"id_card" validate:"required,validIDCard"`
}

type YYSY4B37Request struct {
	MobileNo string `json:"mobile_no" validate:"required,min=11,max=11,validMobileNo"`
}
type YYSY4B21Request struct {
	MobileNo string `json:"mobile_no" validate:"required,min=11,max=11,validMobileNo"`
}
type YYSY6F2ERequest struct {
	MobileNo   string `json:"mobile_no" validate:"required,min=11,max=11,validMobileNo"`
	MobileType string `json:"mobile_type" validate:"omitempty,validMobileType"`
	IDCard     string `json:"id_card" validate:"required,validIDCard"`
	Name       string `json:"name" validate:"required,min=1,validName"`
}
type YYSY09CDRequest struct {
	MobileNo   string `json:"mobile_no" validate:"required,min=11,max=11,validMobileNo"`
	MobileType string `json:"mobile_type" validate:"omitempty,validMobileType"`
	IDCard     string `json:"id_card" validate:"required,validIDCard"`
	Name       string `json:"name" validate:"required,min=1,validName"`
}
type YYSYBE08Request struct {
	MobileNo string `json:"mobile_no" validate:"required,min=11,max=11,validMobileNo"`
	Name     string `json:"name" validate:"required,min=1,validName"`
}
type YYSYD50FRequest struct {
	MobileNo string `json:"mobile_no" validate:"required,min=11,max=11,validMobileNo"`
	IDCard   string `json:"id_card" validate:"required,validIDCard"`
}
type YYSYF7DBRequest struct {
	MobileNo  string `json:"mobile_no" validate:"required,min=11,max=11,validMobileNo"`
	StartDate string `json:"start_date" validate:"required,validDate" encrypt:"false"`
}
type IVYZ9A2BRequest struct {
	IDCard string `json:"id_card" validate:"required,validIDCard"`
	Name   string `json:"name" validate:"required,min=1,validName"`
}
