package user

import (
	"net/http"

	"github.com/zeromicro/go-zero/rest/httpx"
	"tianyuan-api/apps/gateway/internal/logic/user"
	"tianyuan-api/apps/gateway/internal/svc"
	"tianyuan-api/apps/gateway/internal/types"

	xhttp "github.com/zeromicro/x/http"
)

func EnterpriseAuthHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.EnterpriseAuthReq
		if err := httpx.Parse(r, &req); err != nil {
			xhttp.JsonBaseResponseCtx(r.Context(), w, err)
			return
		}

		l := user.NewEnterpriseAuthLogic(r.Context(), svcCtx)
		err := l.EnterpriseAuth(&req)
		if err != nil {
			xhttp.JsonBaseResponseCtx(r.Context(), w, err)
		} else {
			xhttp.JsonBaseResponseCtx(r.Context(), w, nil)
		}
	}
}
