package whitelistr

import (
	"net/http"

	"github.com/zeromicro/go-zero/rest/httpx"
	"tianyuan-api/apps/gateway/internal/logic/whitelistr"
	"tianyuan-api/apps/gateway/internal/svc"
	"tianyuan-api/apps/gateway/internal/types"

	xhttp "github.com/zeromicro/x/http"
)

func AddWhitelistHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.AddWhitelistReq
		if err := httpx.Parse(r, &req); err != nil {
			xhttp.JsonBaseResponseCtx(r.Context(), w, err)
			return
		}

		l := whitelistr.NewAddWhitelistLogic(r.Context(), svcCtx)
		err := l.AddWhitelist(&req)
		if err != nil {
			xhttp.JsonBaseResponseCtx(r.Context(), w, err)
		} else {
			xhttp.JsonBaseResponseCtx(r.Context(), w, nil)
		}
	}
}
