package auth

import (
	"context"
	"github.com/zeromicro/go-zero/core/logx"
	"tianyuan-api/apps/gateway/internal/svc"
	"tianyuan-api/apps/gateway/internal/types"
	"tianyuan-api/apps/user/user"
)

type PhoneLoginUserLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewPhoneLoginUserLogic(ctx context.Context, svcCtx *svc.ServiceContext) *PhoneLoginUserLogic {
	return &PhoneLoginUserLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *PhoneLoginUserLogic) PhoneLoginUser(req *types.PhoneLoginReq) (token string, err error) {
	loginResp, err := l.svcCtx.AuthRpc.PhoneLoginUser(l.ctx, &user.PhoneLoginReq{
		Phone: req.Phone,
		Code:  req.Code,
	})
	if err != nil {
		return "", err
	}
	// 返回成功的登录响应
	return loginResp.Token, nil
}
