package apirequest

import (
	"context"
	"encoding/json"
	"github.com/zeromicro/go-zero/core/logx"
	"tianyuan-api/apps/mqs/internal/svc"
	"tianyuan-api/apps/user/user"
	"tianyuan-api/pkg/models"
)

type Charge struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewCharge(ctx context.Context, svcCtx *svc.ServiceContext) *Charge {
	return &Charge{
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *Charge) Consume(ctx context.Context, key, val string) error {
	var apiRequestMessage models.ApiRequestMessage
	err := json.Unmarshal([]byte(val), &apiRequestMessage)
	if err != nil {
		return err
	}
	logx.Infof("Charge val :%v", apiRequestMessage)
	if !apiRequestMessage.Charges {
		return nil
	}
	_, updateWalletErr := l.svcCtx.WalletRpc.UpdateWallet(ctx, &user.UpdateWalletRequest{UserId: apiRequestMessage.UserId, TransactionId: apiRequestMessage.TransactionID, ProductCode: apiRequestMessage.ProductCode, Charge: apiRequestMessage.Charges, Remark: apiRequestMessage.Remark})
	if updateWalletErr != nil {
		return err
	}
	return nil
}
