package config

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/zrpc"
)

type Config struct {
	zrpc.RpcServerConf
	DataSource string          // 数据库连接的 DSN 字符串
	CacheRedis cache.CacheConf // 缓存配置，使用 go-zero 自带的缓存配置结构体
	Alipay     AlipayConfig
	TopUp      TopUpConfig
	UserRpc    zrpc.RpcClientConf
}
type AlipayConfig struct {
	AppID           string
	PrivateKey      string
	AlipayPublicKey string
	IsProduction    bool
}
type TopUpConfig struct {
	MaxTopUpAmount int64
	Subject        string
	NotifyURL      string
	ReturnURL      string
}
