package productlogic

import (
	"context"
	"tianyuan-api/apps/sentinel/internal/model"
	"tianyuan-api/apps/sentinel/internal/svc"
	"tianyuan-api/apps/sentinel/sentinel"
	"tianyuan-api/pkg/sqlutil"

	"github.com/zeromicro/go-zero/core/logx"
)

type UpdateProductLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewUpdateProductLogic(ctx context.Context, svcCtx *svc.ServiceContext) *UpdateProductLogic {
	return &UpdateProductLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *UpdateProductLogic) UpdateProduct(in *sentinel.UpdateProductRequest) (*sentinel.Product, error) {
	err := l.svcCtx.ProductsModel.Update(l.ctx, &model.Products{
		Id:                 in.Id,
		ProductName:        in.ProductName,
		ProductCode:        in.ProductCode,
		ProductDescription: sqlutil.StringToNullString(in.ProductDescription),
		ProductContent:     sqlutil.StringToNullString(in.ProductContent),
		ProductPrice:       in.ProductPrice,
		ProductGroup:       in.ProductGroup,
	})
	if err != nil {
		return nil, err
	}
	return &sentinel.Product{}, nil
}
