// Code generated by goctl. DO NOT EDIT.
// versions:
//  goctl version: 1.7.2

package model

import (
	"context"
	"database/sql"
	"fmt"
	"strings"
	"time"

	"github.com/zeromicro/go-zero/core/stores/builder"
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlc"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
	"github.com/zeromicro/go-zero/core/stringx"
)

var (
	payOrderFieldNames          = builder.RawFieldNames(&PayOrder{})
	payOrderRows                = strings.Join(payOrderFieldNames, ",")
	payOrderRowsExpectAutoSet   = strings.Join(stringx.Remove(payOrderFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), ",")
	payOrderRowsWithPlaceHolder = strings.Join(stringx.Remove(payOrderFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), "=?,") + "=?"

	cachePayOrderIdPrefix         = "cache:payOrder:id:"
	cachePayOrderOutTradeNoPrefix = "cache:payOrder:outTradeNo:"
)

type (
	payOrderModel interface {
		Insert(ctx context.Context, data *PayOrder) (sql.Result, error)
		FindOne(ctx context.Context, id int64) (*PayOrder, error)
		FindOneByOutTradeNo(ctx context.Context, outTradeNo string) (*PayOrder, error)
		Update(ctx context.Context, data *PayOrder) error
		Delete(ctx context.Context, id int64) error
	}

	defaultPayOrderModel struct {
		sqlc.CachedConn
		table string
	}

	PayOrder struct {
		Id          int64        `db:"id"`           // 主键
		UserId      int64        `db:"user_id"`      // 用户ID
		OutTradeNo  string       `db:"out_trade_no"` // 商户订单号，唯一
		Amount      float64      `db:"amount"`       // 支付金额
		Status      int64        `db:"status"`       // 订单状态 0-待支付, 1-支付成功, 2-支付失败
		CreatedAt   time.Time    `db:"created_at"`   // 创建时间
		UpdatedAt   time.Time    `db:"updated_at"`   // 更新时间
		PaymentTime sql.NullTime `db:"payment_time"` // 支付完成时间
	}
)

func newPayOrderModel(conn sqlx.SqlConn, c cache.CacheConf, opts ...cache.Option) *defaultPayOrderModel {
	return &defaultPayOrderModel{
		CachedConn: sqlc.NewConn(conn, c, opts...),
		table:      "`pay_order`",
	}
}

func (m *defaultPayOrderModel) Delete(ctx context.Context, id int64) error {
	data, err := m.FindOne(ctx, id)
	if err != nil {
		return err
	}

	payOrderIdKey := fmt.Sprintf("%s%v", cachePayOrderIdPrefix, id)
	payOrderOutTradeNoKey := fmt.Sprintf("%s%v", cachePayOrderOutTradeNoPrefix, data.OutTradeNo)
	_, err = m.ExecCtx(ctx, func(ctx context.Context, conn sqlx.SqlConn) (result sql.Result, err error) {
		query := fmt.Sprintf("delete from %s where `id` = ?", m.table)
		return conn.ExecCtx(ctx, query, id)
	}, payOrderIdKey, payOrderOutTradeNoKey)
	return err
}

func (m *defaultPayOrderModel) FindOne(ctx context.Context, id int64) (*PayOrder, error) {
	payOrderIdKey := fmt.Sprintf("%s%v", cachePayOrderIdPrefix, id)
	var resp PayOrder
	err := m.QueryRowCtx(ctx, &resp, payOrderIdKey, func(ctx context.Context, conn sqlx.SqlConn, v any) error {
		query := fmt.Sprintf("select %s from %s where `id` = ? limit 1", payOrderRows, m.table)
		return conn.QueryRowCtx(ctx, v, query, id)
	})
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultPayOrderModel) FindOneByOutTradeNo(ctx context.Context, outTradeNo string) (*PayOrder, error) {
	payOrderOutTradeNoKey := fmt.Sprintf("%s%v", cachePayOrderOutTradeNoPrefix, outTradeNo)
	var resp PayOrder
	err := m.QueryRowIndexCtx(ctx, &resp, payOrderOutTradeNoKey, m.formatPrimary, func(ctx context.Context, conn sqlx.SqlConn, v any) (i any, e error) {
		query := fmt.Sprintf("select %s from %s where `out_trade_no` = ? limit 1", payOrderRows, m.table)
		if err := conn.QueryRowCtx(ctx, &resp, query, outTradeNo); err != nil {
			return nil, err
		}
		return resp.Id, nil
	}, m.queryPrimary)
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultPayOrderModel) Insert(ctx context.Context, data *PayOrder) (sql.Result, error) {
	payOrderIdKey := fmt.Sprintf("%s%v", cachePayOrderIdPrefix, data.Id)
	payOrderOutTradeNoKey := fmt.Sprintf("%s%v", cachePayOrderOutTradeNoPrefix, data.OutTradeNo)
	ret, err := m.ExecCtx(ctx, func(ctx context.Context, conn sqlx.SqlConn) (result sql.Result, err error) {
		query := fmt.Sprintf("insert into %s (%s) values (?, ?, ?, ?, ?)", m.table, payOrderRowsExpectAutoSet)
		return conn.ExecCtx(ctx, query, data.UserId, data.OutTradeNo, data.Amount, data.Status, data.PaymentTime)
	}, payOrderIdKey, payOrderOutTradeNoKey)
	return ret, err
}

func (m *defaultPayOrderModel) Update(ctx context.Context, newData *PayOrder) error {
	data, err := m.FindOne(ctx, newData.Id)
	if err != nil {
		return err
	}

	payOrderIdKey := fmt.Sprintf("%s%v", cachePayOrderIdPrefix, data.Id)
	payOrderOutTradeNoKey := fmt.Sprintf("%s%v", cachePayOrderOutTradeNoPrefix, data.OutTradeNo)
	_, err = m.ExecCtx(ctx, func(ctx context.Context, conn sqlx.SqlConn) (result sql.Result, err error) {
		query := fmt.Sprintf("update %s set %s where `id` = ?", m.table, payOrderRowsWithPlaceHolder)
		return conn.ExecCtx(ctx, query, newData.UserId, newData.OutTradeNo, newData.Amount, newData.Status, newData.PaymentTime, newData.Id)
	}, payOrderIdKey, payOrderOutTradeNoKey)
	return err
}

func (m *defaultPayOrderModel) formatPrimary(primary any) string {
	return fmt.Sprintf("%s%v", cachePayOrderIdPrefix, primary)
}

func (m *defaultPayOrderModel) queryPrimary(ctx context.Context, conn sqlx.SqlConn, v, primary any) error {
	query := fmt.Sprintf("select %s from %s where `id` = ? limit 1", payOrderRows, m.table)
	return conn.QueryRowCtx(ctx, v, query, primary)
}

func (m *defaultPayOrderModel) tableName() string {
	return m.table
}
