// Code generated by goctl. DO NOT EDIT.
// versions:
//  goctl version: 1.7.2

package model

import (
	"context"
	"database/sql"
	"fmt"
	"strings"
	"time"

	"github.com/zeromicro/go-zero/core/stores/builder"
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlc"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
	"github.com/zeromicro/go-zero/core/stringx"
)

var (
	productsFieldNames          = builder.RawFieldNames(&Products{})
	productsRows                = strings.Join(productsFieldNames, ",")
	productsRowsExpectAutoSet   = strings.Join(stringx.Remove(productsFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), ",")
	productsRowsWithPlaceHolder = strings.Join(stringx.Remove(productsFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), "=?,") + "=?"

	cacheProductsIdPrefix          = "cache:products:id:"
	cacheProductsProductCodePrefix = "cache:products:productCode:"
)

type (
	productsModel interface {
		Insert(ctx context.Context, data *Products) (sql.Result, error)
		FindOne(ctx context.Context, id int64) (*Products, error)
		FindOneByProductCode(ctx context.Context, productCode string) (*Products, error)
		Update(ctx context.Context, data *Products) error
		Delete(ctx context.Context, id int64) error
	}

	defaultProductsModel struct {
		sqlc.CachedConn
		table string
	}

	Products struct {
		Id                 int64          `db:"id"`                  // 产品ID
		ProductName        string         `db:"product_name"`        // 产品名称
		ProductCode        string         `db:"product_code"`        // 产品编号
		ProductDescription sql.NullString `db:"product_description"` // 产品简介
		ProductContent     sql.NullString `db:"product_content"`     // 产品内容
		ProductGroup       string         `db:"product_group"`       // 产品分类
		ProductPrice       float64        `db:"product_price"`       // 产品价格
		IsEnabled          int64          `db:"is_enabled"`          // 是否启用，1-启用，0-禁用
		IsVisible          int64          `db:"is_visible"`          // 是否展示，1-展示，0-隐藏
		CreatedAt          time.Time      `db:"created_at"`          // 创建时间
		UpdatedAt          time.Time      `db:"updated_at"`          // 更新时间
	}
)

func newProductsModel(conn sqlx.SqlConn, c cache.CacheConf, opts ...cache.Option) *defaultProductsModel {
	return &defaultProductsModel{
		CachedConn: sqlc.NewConn(conn, c, opts...),
		table:      "`products`",
	}
}

func (m *defaultProductsModel) Delete(ctx context.Context, id int64) error {
	data, err := m.FindOne(ctx, id)
	if err != nil {
		return err
	}

	productsIdKey := fmt.Sprintf("%s%v", cacheProductsIdPrefix, id)
	productsProductCodeKey := fmt.Sprintf("%s%v", cacheProductsProductCodePrefix, data.ProductCode)
	_, err = m.ExecCtx(ctx, func(ctx context.Context, conn sqlx.SqlConn) (result sql.Result, err error) {
		query := fmt.Sprintf("delete from %s where `id` = ?", m.table)
		return conn.ExecCtx(ctx, query, id)
	}, productsIdKey, productsProductCodeKey)
	return err
}

func (m *defaultProductsModel) FindOne(ctx context.Context, id int64) (*Products, error) {
	productsIdKey := fmt.Sprintf("%s%v", cacheProductsIdPrefix, id)
	var resp Products
	err := m.QueryRowCtx(ctx, &resp, productsIdKey, func(ctx context.Context, conn sqlx.SqlConn, v any) error {
		query := fmt.Sprintf("select %s from %s where `id` = ? limit 1", productsRows, m.table)
		return conn.QueryRowCtx(ctx, v, query, id)
	})
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultProductsModel) FindOneByProductCode(ctx context.Context, productCode string) (*Products, error) {
	productsProductCodeKey := fmt.Sprintf("%s%v", cacheProductsProductCodePrefix, productCode)
	var resp Products
	err := m.QueryRowIndexCtx(ctx, &resp, productsProductCodeKey, m.formatPrimary, func(ctx context.Context, conn sqlx.SqlConn, v any) (i any, e error) {
		query := fmt.Sprintf("select %s from %s where `product_code` = ? limit 1", productsRows, m.table)
		if err := conn.QueryRowCtx(ctx, &resp, query, productCode); err != nil {
			return nil, err
		}
		return resp.Id, nil
	}, m.queryPrimary)
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultProductsModel) Insert(ctx context.Context, data *Products) (sql.Result, error) {
	productsIdKey := fmt.Sprintf("%s%v", cacheProductsIdPrefix, data.Id)
	productsProductCodeKey := fmt.Sprintf("%s%v", cacheProductsProductCodePrefix, data.ProductCode)
	ret, err := m.ExecCtx(ctx, func(ctx context.Context, conn sqlx.SqlConn) (result sql.Result, err error) {
		query := fmt.Sprintf("insert into %s (%s) values (?, ?, ?, ?, ?, ?, ?, ?)", m.table, productsRowsExpectAutoSet)
		return conn.ExecCtx(ctx, query, data.ProductName, data.ProductCode, data.ProductDescription, data.ProductContent, data.ProductGroup, data.ProductPrice, data.IsEnabled, data.IsVisible)
	}, productsIdKey, productsProductCodeKey)
	return ret, err
}

func (m *defaultProductsModel) Update(ctx context.Context, newData *Products) error {
	data, err := m.FindOne(ctx, newData.Id)
	if err != nil {
		return err
	}

	productsIdKey := fmt.Sprintf("%s%v", cacheProductsIdPrefix, data.Id)
	productsProductCodeKey := fmt.Sprintf("%s%v", cacheProductsProductCodePrefix, data.ProductCode)
	_, err = m.ExecCtx(ctx, func(ctx context.Context, conn sqlx.SqlConn) (result sql.Result, err error) {
		query := fmt.Sprintf("update %s set %s where `id` = ?", m.table, productsRowsWithPlaceHolder)
		return conn.ExecCtx(ctx, query, newData.ProductName, newData.ProductCode, newData.ProductDescription, newData.ProductContent, newData.ProductGroup, newData.ProductPrice, newData.IsEnabled, newData.IsVisible, newData.Id)
	}, productsIdKey, productsProductCodeKey)
	return err
}

func (m *defaultProductsModel) formatPrimary(primary any) string {
	return fmt.Sprintf("%s%v", cacheProductsIdPrefix, primary)
}

func (m *defaultProductsModel) queryPrimary(ctx context.Context, conn sqlx.SqlConn, v, primary any) error {
	query := fmt.Sprintf("select %s from %s where `id` = ? limit 1", productsRows, m.table)
	return conn.QueryRowCtx(ctx, v, query, primary)
}

func (m *defaultProductsModel) tableName() string {
	return m.table
}
