package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ SecretsModel = (*customSecretsModel)(nil)

type (
	// SecretsModel is an interface to be customized, add more methods here,
	// and implement the added methods in customSecretsModel.
	SecretsModel interface {
		secretsModel
	}

	customSecretsModel struct {
		*defaultSecretsModel
	}
)

// NewSecretsModel returns a model for the database table.
func NewSecretsModel(conn sqlx.SqlConn, c cache.CacheConf, opts ...cache.Option) SecretsModel {
	return &customSecretsModel{
		defaultSecretsModel: newSecretsModel(conn, c, opts...),
	}
}
