// Code generated by goctl. DO NOT EDIT.
// versions:
//  goctl version: 1.7.2

package model

import (
	"context"
	"database/sql"
	"fmt"
	"strings"
	"time"

	"github.com/zeromicro/go-zero/core/stores/builder"
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlc"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
	"github.com/zeromicro/go-zero/core/stringx"
)

var (
	userProductsFieldNames          = builder.RawFieldNames(&UserProducts{})
	userProductsRows                = strings.Join(userProductsFieldNames, ",")
	userProductsRowsExpectAutoSet   = strings.Join(stringx.Remove(userProductsFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), ",")
	userProductsRowsWithPlaceHolder = strings.Join(stringx.Remove(userProductsFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), "=?,") + "=?"

	cacheUserProductsIdPrefix = "cache:userProducts:id:"
)

type (
	userProductsModel interface {
		Insert(ctx context.Context, data *UserProducts) (sql.Result, error)
		FindOne(ctx context.Context, id int64) (*UserProducts, error)
		Update(ctx context.Context, data *UserProducts) error
		Delete(ctx context.Context, id int64) error
	}

	defaultUserProductsModel struct {
		sqlc.CachedConn
		table string
	}

	UserProducts struct {
		Id           int64     `db:"id"`            // 用户产品ID
		UserId       int64     `db:"user_id"`       // 用户ID
		ProductId    int64     `db:"product_id"`    // 产品ID
		ProductPrice float64   `db:"product_price"` // 产品价格
		CreatedAt    time.Time `db:"created_at"`    // 创建时间
		UpdatedAt    time.Time `db:"updated_at"`    // 更新时间
	}
)

func newUserProductsModel(conn sqlx.SqlConn, c cache.CacheConf, opts ...cache.Option) *defaultUserProductsModel {
	return &defaultUserProductsModel{
		CachedConn: sqlc.NewConn(conn, c, opts...),
		table:      "`user_products`",
	}
}

func (m *defaultUserProductsModel) Delete(ctx context.Context, id int64) error {
	userProductsIdKey := fmt.Sprintf("%s%v", cacheUserProductsIdPrefix, id)
	_, err := m.ExecCtx(ctx, func(ctx context.Context, conn sqlx.SqlConn) (result sql.Result, err error) {
		query := fmt.Sprintf("delete from %s where `id` = ?", m.table)
		return conn.ExecCtx(ctx, query, id)
	}, userProductsIdKey)
	return err
}

func (m *defaultUserProductsModel) FindOne(ctx context.Context, id int64) (*UserProducts, error) {
	userProductsIdKey := fmt.Sprintf("%s%v", cacheUserProductsIdPrefix, id)
	var resp UserProducts
	err := m.QueryRowCtx(ctx, &resp, userProductsIdKey, func(ctx context.Context, conn sqlx.SqlConn, v any) error {
		query := fmt.Sprintf("select %s from %s where `id` = ? limit 1", userProductsRows, m.table)
		return conn.QueryRowCtx(ctx, v, query, id)
	})
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultUserProductsModel) Insert(ctx context.Context, data *UserProducts) (sql.Result, error) {
	userProductsIdKey := fmt.Sprintf("%s%v", cacheUserProductsIdPrefix, data.Id)
	ret, err := m.ExecCtx(ctx, func(ctx context.Context, conn sqlx.SqlConn) (result sql.Result, err error) {
		query := fmt.Sprintf("insert into %s (%s) values (?, ?, ?)", m.table, userProductsRowsExpectAutoSet)
		return conn.ExecCtx(ctx, query, data.UserId, data.ProductId, data.ProductPrice)
	}, userProductsIdKey)
	return ret, err
}

func (m *defaultUserProductsModel) Update(ctx context.Context, data *UserProducts) error {
	userProductsIdKey := fmt.Sprintf("%s%v", cacheUserProductsIdPrefix, data.Id)
	_, err := m.ExecCtx(ctx, func(ctx context.Context, conn sqlx.SqlConn) (result sql.Result, err error) {
		query := fmt.Sprintf("update %s set %s where `id` = ?", m.table, userProductsRowsWithPlaceHolder)
		return conn.ExecCtx(ctx, query, data.UserId, data.ProductId, data.ProductPrice, data.Id)
	}, userProductsIdKey)
	return err
}

func (m *defaultUserProductsModel) formatPrimary(primary any) string {
	return fmt.Sprintf("%s%v", cacheUserProductsIdPrefix, primary)
}

func (m *defaultUserProductsModel) queryPrimary(ctx context.Context, conn sqlx.SqlConn, v, primary any) error {
	query := fmt.Sprintf("select %s from %s where `id` = ? limit 1", userProductsRows, m.table)
	return conn.QueryRowCtx(ctx, v, query, primary)
}

func (m *defaultUserProductsModel) tableName() string {
	return m.table
}
