package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ ApiRequestsModel = (*customApiRequestsModel)(nil)

type (
	// ApiRequestsModel is an interface to be customized, add more methods here,
	// and implement the added methods in customApiRequestsModel.
	ApiRequestsModel interface {
		apiRequestsModel
	}

	customApiRequestsModel struct {
		*defaultApiRequestsModel
	}
)

// NewApiRequestsModel returns a model for the database table.
func NewApiRequestsModel(conn sqlx.SqlConn, c cache.CacheConf, opts ...cache.Option) ApiRequestsModel {
	return &customApiRequestsModel{
		defaultApiRequestsModel: newApiRequestsModel(conn, c, opts...),
	}
}
