package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ UserConfigModel = (*customUserConfigModel)(nil)

type (
	// UserConfigModel is an interface to be customized, add more methods here,
	// and implement the added methods in customUserConfigModel.
	UserConfigModel interface {
		userConfigModel
	}

	customUserConfigModel struct {
		*defaultUserConfigModel
	}
)

// NewUserConfigModel returns a model for the database table.
func NewUserConfigModel(conn sqlx.SqlConn, c cache.CacheConf, opts ...cache.Option) UserConfigModel {
	return &customUserConfigModel{
		defaultUserConfigModel: newUserConfigModel(conn, c, opts...),
	}
}
