package sqlutil

import "database/sql"

// StringToNullString 将 string 转换为 sql.NullString
func StringToNullString(s string) sql.NullString {
	return sql.NullString{
		String: s,
		Valid:  s != "",
	}
}

// NullStringToString 将 sql.NullString 转换为 string
func NullStringToString(ns sql.NullString) string {
	if ns.Valid {
		return ns.String
	}
	return ""
}
